package jalview.javascript.web;

import jalview.util.Platform;

import java.net.URI;
import java.net.URISyntaxException;

/* this class is a proxy for 
 * 
 */
public class WebResource
{

  private String endpoint, params = "";
  
  public WebResource(String endpoint) {
    this.endpoint = endpoint;
  }
  

  public WebResource queryParam(String key, String value)
  {
    params += (params == "" ? "?" : "&") + key + "=";
    params += Platform.encodeURI(value);
    return this;
  }

  public URI getURI()
  {
    try
    {
      return new URI(endpoint + params);
    } catch (URISyntaxException e)
    {
      e.printStackTrace();
      return null;
    }
  }

  public Builder accept(String... encoding)
  {
    return  new Builder(getURI(), encoding);
  }
  
  
  public static class Builder {
      private URI uri;
      private String[] encoding;

      public Builder(URI uri, String... encoding)
    {
        this.uri = uri;
        this.encoding = encoding; // application/json
        
      // TODO Auto-generated constructor stub
    }

      public ClientResponse get(Class<?> c) {
        String data = uri.toString();
        // c will be ClientResponse 
        data = Platform.getFileAsString(data);
        return new ClientResponse(data, encoding);
      }
  }
 
  
  

}
